# MapperReadKeyValuesRepo

open class MapperReadKeyValuesRepo < FromKey , FromValue , ToKey , ToValue >(to: ReadKeyValuesRepo < ToKey , ToValue >, mapper: MapperRepo < FromKey , FromValue , ToKey , ToValue >) : ReadKeyValuesRepo < FromKey , FromValue > , MapperRepo < FromKey , FromValue , ToKey , ToValue > (source)

Read-only one-to-many key-values repository adapter that applies type mapping via MapperRepo. Converts outer (From) key/value types to inner (To) types before delegating to to, and converts results back from inner to outer types.

#### Parameters

to

The underlying ReadKeyValuesRepo to delegate operations to

mapper

The MapperRepo providing bidirectional key/value type conversions

#### Type Parameters

FromKey

The outer key type exposed by this repo

FromValue

The outer value type exposed by this repo

ToKey

The inner key type used by the underlying to repo

ToValue

The inner value type used by the underlying to repo

## Constructors

MapperReadKeyValuesRepo
Link copied to clipboard
constructor(to: ReadKeyValuesRepo < ToKey , ToValue >, mapper: MapperRepo < FromKey , FromValue , ToKey , ToValue >)

## Properties

keyMapper
Link copied to clipboard
open override val keyMapper : SimpleSuspendableMapper < FromKey , ToKey >

Provides a mapper for converting keys between inner and outer types.

valueMapper
Link copied to clipboard
open override val valueMapper : SimpleSuspendableMapper < FromValue , ToValue >

Provides a mapper for converting values between inner and outer types.

## Functions

asReadKeyValueRepo
Link copied to clipboard
fun < K , V > ReadKeyValuesRepo < K , V >. asReadKeyValueRepo (): ReadKeyValueFromKeyValuesRepo < K , V >

Wraps this ReadKeyValuesRepo as a ReadKeyValueFromKeyValuesRepo, exposing each key mapped to a List of all associated values.

cached
Link copied to clipboard
fun < Key , Value > ReadKeyValuesRepo < Key , Value >. cached (kvCache: KVCache < Key , List < Value >>, locker: SmartRWLocker = SmartRWLocker()): ReadKeyValuesCacheRepo < Key , Value >
fun < Key , Value > ReadKeyValuesRepo < Key , Value >. cached (kvCache: KeyValueRepo < Key , List < Value >>, locker: SmartRWLocker = SmartRWLocker()): FullReadKeyValuesCacheRepo < Key , Value >
contains
Link copied to clipboard
open suspend override fun contains (k: FromKey ): Boolean

Checks if the specified key exists in the repository.

open suspend override fun contains (k: FromKey , v: FromValue ): Boolean

Checks if the specified key-value pair exists in the repository.

count
Link copied to clipboard
open suspend override fun count (): Long

Returns the total count of key-value pairs in the repository.

open suspend override fun count (k: FromKey ): Long

Returns the count of values associated with the specified key.

diff
Link copied to clipboard
suspend fun < Id , Registered > ReadKeyValuesRepo < Id , Registered >. diff (other: Map < Id , List < Registered >>): MapDiff < Id , List < Registered >>

Computes the difference between all entries in this ReadKeyValuesRepo and the given other map.

directlyCached
Link copied to clipboard
fun < Key , Value > ReadKeyValuesRepo < Key , Value >. directlyCached (kvCache: KeyValueRepo < Key , List < Value >>, locker: SmartRWLocker = SmartRWLocker()): DirectFullReadKeyValuesCacheRepo < Key , Value >
get
Link copied to clipboard
open suspend override fun get (k: FromKey , pagination: Pagination , reversed: Boolean = false): PaginationResult < FromValue >

Retrieves a paginated list of values associated with the given key.

getAll
Link copied to clipboard
open suspend fun getAll (reverseLists: Boolean = false): Map < FromKey , List < FromValue >>

WARNING!!! THIS METHOD PROBABLY IS NOT EFFICIENT, USE WITH CAUTION

open suspend fun getAll (k: FromKey , reversed: Boolean = false): List < FromValue >
keys
Link copied to clipboard
open suspend override fun keys (pagination: Pagination , reversed: Boolean = false): PaginationResult < FromKey >

Retrieves a paginated list of keys.

open suspend override fun keys (v: FromValue , pagination: Pagination , reversed: Boolean = false): PaginationResult < FromKey >

Retrieves keys that have the specified value associated with them.

maxPagePagination
Link copied to clipboard
inline suspend fun ReadKeyValuesRepo <*, *>. maxPagePagination (): SimplePagination

Creates a pagination starting from the first page with size equal to the total count of items in this ReadKeyValuesRepo. This effectively creates a single page containing all items.

toInnerKey
Link copied to clipboard
open suspend override fun ToKey . toInnerKey (): FromKey

Converts a key from the outer type to the inner type.

toInnerValue
Link copied to clipboard
open suspend override fun ToValue . toInnerValue (): FromValue

Converts a value from the outer type to the inner type.

toOutKey
Link copied to clipboard
open suspend override fun FromKey . toOutKey (): ToKey

Converts a key from the inner type to the outer type.

toOutValue
Link copied to clipboard
open suspend override fun FromValue . toOutValue (): ToValue

Converts a value from the inner type to the outer type.

withMapper
Link copied to clipboard
inline fun < FromKey , FromValue , ToKey , ToValue > ReadKeyValuesRepo < ToKey , ToValue >. withMapper (mapper: MapperRepo < FromKey , FromValue , ToKey , ToValue >): ReadKeyValuesRepo < FromKey , FromValue >

Wraps this ReadKeyValuesRepo with a MapperRepo to expose a mapped ReadKeyValuesRepo.

inline fun < FromKey , FromValue , ToKey , ToValue > ReadKeyValuesRepo < ToKey , ToValue >. withMapper (noinline keyFromToTo: suspend FromKey .() -> ToKey = { this as ToKey }, noinline valueFromToTo: suspend FromValue .() -> ToValue = { this as ToValue }, noinline keyToToFrom: suspend ToKey .() -> FromKey = { this as FromKey }, noinline valueToToFrom: suspend ToValue .() -> FromValue = { this as FromValue }): ReadKeyValuesRepo < FromKey , FromValue >

Wraps this ReadKeyValuesRepo with inline conversion lambdas to expose a mapped ReadKeyValuesRepo.